from qt import *

import os

class LConfig(QSettings):
	def __init__(self, appname):
		QSettings.__init__(self)
		self.appname = appname
		path = str(os.path.expanduser("~/.kde/share/config"))
		self.insertSearchPath(QSettings.Unix, path)

	def writeEntry(self, section, name, string):
		QSettings.writeEntry(self, "/%s/%s/%s"%(self.appname, section, name), string)

	def readEntry(self, section, name, default=False):
		s, b = QSettings.readEntry(self, "/%s/%s/%s"%(self.appname, section, name))
		if b:
			return str(s)
		return default
		
	def writeEntryRect(self, section, name, r):
		l = [r.left(), r.top(), r.width(), r.height()]
		QSettings.writeEntry(self, "/%s/%s/%s"%(self.appname, section, name), str(l))
		
	def readEntryRect(self, section, name, default):
		s, b = QSettings.readEntry(self, "/%s/%s/%s"%(self.appname, section, name))
		if b and s:
			l = eval(str(s))
			if len(l) == 4:
				return QRect(l[0], l[1], l[2], l[3])
		return default

	def writeEntryList(self, section, name, list):
		QSettings.writeEntry(self, "/%s/%s/%s"%(self.appname, section, name), str(list))
		
	def readEntryList(self, section, name, default=[]):
		s, b = QSettings.readEntry(self, "/%s/%s/%s"%(self.appname, section, name))
		if b:
			return eval(str(s))
		return default
		
	def writeEntryBool(self, section, name, bool):
		if bool:
			s = "True"
		else:
			s = "False"
		QSettings.writeEntry(self, "/%s/%s/%s"%(self.appname, section, name), s)

	def readEntryBool(self, section, name, default=False):
		print section, name
		s, b = QSettings.readEntry(self, "/%s/%s/%s"%(self.appname, section, name))
		if b:
			return s == "True"
		return default
		
