from qt import *
from utils import *
from backtick import *
from kdeemul import *

class LEmail(QDialog):
	def __init__(self, parent, lib, count, bytes = None):
		QDialog.__init__(self, parent, "Lphoto", True)
		self.count = count
		self.byteSize = bytes
		self.lib = lib
		self.setCaption(i18n("Send Email"))
		
		gl = QGridLayout(self,3,2,10)
		l = QLabel(i18n("Image Size:"), self)
		gl.addWidget(l,0,0)
		self.sizeCombo = QComboBox(self)
		gl.addWidget(self.sizeCombo,0,1)

		vl = QVBoxLayout()
		gl.addLayout(vl,2,1)
		if count == 1:
			t = "1 photo"
		else:
			t = "%d photos" % (count)
		l = QLabel(t, self)
		vl.addWidget(l)
		self. sizeLabel = QLabel("", self)
		vl.addWidget(self.sizeLabel)
		vl.addSpacing(10)
		vl.addStretch()
		
		hl = QHBoxLayout()
		gl.addLayout(hl,3,1)
		hl.addStretch()
		self.composeButton = QPushButton(i18n("Send EMail..."), self)
		hl.addWidget(self.composeButton)
		self.composeButton.setDefault(True)
		hl.addSpacing(5)
		self.cancelButton = QPushButton(i18n("Cancel"), self)
		hl.addWidget(self.cancelButton)
		
		# init sizeCombo
		self.sizes = []
		self.sizes.append([i18n("Small (320x240)"), QSize(320,240), 65000])
##~ 		self.sizes.append(["        (480x320)", QSize(480,320), 95000])
		self.sizes.append([i18n("Medium (640x480)"), QSize(640,480), 124000])
		self.sizes.append([i18n("Large (1200x900)"), QSize(1200,900), 180000])
		self.sizes.append([i18n("Full (Actual Size)"), None, None])
		
		for size in self.sizes:
			self.sizeCombo.insertItem(size[0])
		
		QObject.connect(self.composeButton, SIGNAL("clicked()"), self, SLOT("accept()"))
		QObject.connect(self.cancelButton, SIGNAL("clicked()"), self, SLOT("reject()"))
		QObject.connect(self.sizeCombo, SIGNAL("activated(int)"), self.slotChangeSize)
		
		self.slotChangeSize(self.sizeCombo.currentItem())
		
	def slotChangeSize(self, i):
		s = self.sizes[i][2]
		if s:
			t = LUtils.humanByteOutput(s*self.count)
		elif self.byteSize:
			t = LUtils.humanByteOutput(self.byteSize)
		else:
			t = "unknown"
		self.sizeLabel.setText(i18n("Estimated Total Size: ")+t)	
		self.size = self.sizes[i][1]
		
	def composeEmail(self, app, keys):
		qsl = QStringList()

		progress = QProgressDialog(i18n("Create EMail"),None,len(keys),None,"progress",True)
		progress.setMinimumDuration(0)
		progress.setCaption(i18n("Creating Photo List"))
		progress.setTotalSteps(len(keys))
		progress.setProgress(0)
		files = []

		for key in keys:
			dict = self.lib.getImage(key)
			progress.setLabelText(i18n("Generating ")+dict['Caption'])
			if self.size:
				(path, filename) = os.path.split(dict['ImagePath'])
				tmpEnv = os.environ.get('TMP','/tmp')
				tmpPath = os.path.join(tmpEnv, filename)
				LUtils.downsizeImage(dict['ImagePath'], tmpPath, self.size)
				qsl.append(str(tmpPath))
				files.append("file://"+str(tmpPath))
			else:
				qsl.append(str(dict['ImagePath']))
				files.append("file://"+str(dict['ImagePath']))
			progress.setProgress(progress.progress()+1)
			if progress.wasCancelled():
				return
##~ 		app.invokeMailer("","","","", "", "", qsl)
		comma = ","
		strFiles = comma.join(files)
		# is mozilla running?
		try:
			mozillaLines = []
			mozillaLines = backtick("ps -u %s | grep mozilla"%(os.getuid()))
		except:
			pass
			
		if len(mozillaLines):
			print "mozilla -remote \"xfeDoCommand(composeMessage, attachment='%s')\" &" % (strFiles)
			os.system("mozilla -remote \"xfeDoCommand(composeMessage, attachment='%s')\" &" % (strFiles))
		else:
			print "mozilla -compose attachment=\"'%s'\" &" %(strFiles)
			os.system("mozilla -compose attachment=\"'%s'\" &" %(strFiles))

		










